% Latexklasse BIS in Anlehnung an die LIV Klasse
%
\ProvidesClass{bis}
\newif\ifpdf\ifx\pdfoutput\undefined\pdffalse\else\pdfoutput=1\pdftrue\fi



\DeclareOption{forInclusion}{%
  \setlength{\topmargin}{0mm}%
  \setlength{\headheight}{0mm}%
  \setlength{\headsep}{0mm}%
  \setlength{\hoffset}{0mm}% 
  \setlength{\voffset}{0mm}% 
  \setlength{\oddsidemargin}{0mm}%
  \setlength{\evensidemargin}{0mm}%
  \setlength{\paperheight}{297mm}%	% Breitenangaben des Dokumentes angepasst: uh
  \setlength{\paperwidth}{210mm}
  \ifpdf%
    \setlength{\pdfpageheight}{297mm}%
    \setlength{\pdfpagewidth}{210mm}%
  \fi}

\newif\iflnienglish\lnienglishfalse
\DeclareOption{english}{\lnienglishtrue}

\ProcessOptions
% 10 pt
\LoadClass[12pt,a4paper,fleqn]{article}	    % Schriftgre gendert: uh
\RequirePackage[english,ngerman]{babel}
\iflnienglish\selectlanguage{english}\def\bbl@main@language{english}\fi
% Blocksatz durch LaTeX-Default
% Satzspiegel
\setlength{\textheight}{192mm}	
\setlength{\textwidth}{136mm}

% Times als Grundschrift
\RequirePackage{times}
% Hyphenation
% Durch normale LaTeX-Parameter verhindert (\doublehyphendemerits)

%\usepackage{fancyhdr}

% Title: Kopie aus article.cls mit anderem \thispagestyle
%\renewcommand\maketitle{\par
%  \begingroup
%    \renewcommand\thefootnote{\@fnsymbol\c@footnote}%
%    \def\@makefnmark{\rlap{\@textsuperscript{\normalfont\@thefnmark}}}%
%    \long\def\@makefntext##1{\parindent 1em\noindent
%            \hb@xt@1.8em{%
%                \hss\@textsuperscript{\normalfont\@thefnmark}}##1}%
%    \if@twocolumn
%      \ifnum \col@number=\@ne
%        \@maketitle
%      \else
%        \twocolumn[\@maketitle]%
%      \fi
%    \else
%      \newpage
%      \global\@topnum\z@   % Prevents figures from going at top of page.
%      \@maketitle
%    \fi
%    \thispagestyle{empty}\@thanks
%  \endgroup
  
  
  
  
  \setcounter{footnote}{0}%
  \global\let\thanks\relax
  \global\let\maketitle\relax
  \global\let\@maketitle\relax
  \global\let\@thanks\@empty
  \global\let\@author\@empty
  \global\let\@date\@empty
  \global\let\@title\@empty
  \global\let\title\relax
  \global\let\author\relax
  \global\let\date\relax
  \global\let\and\relax
%}
%\def\@maketitle{%
%  \newpage
%  \null
%  \vskip 2em%
%  \begin{center}%
%  \let \footnote \thanks
%    {\fontsize{14}{17}\fontseries{b}\selectfont \@title \par}%
%    \vskip 1.5em%
%    {\fontsize{10}{12}\selectfont
%      \lineskip .5em%
%      \begin{tabular}[t]{c}%
%        \@author
%      \end{tabular}\par}%
%    \vskip 1\baselineskip%
%  \end{center}%
%  \par
%  }

% Abstract
%\renewenvironment*{abstract}{%
% \renewcommand{\abstractname}{Kurzfassung}
% \fontsize{9}{10}\selectfont
%    \quotation\noindent{\bfseries \abstractname:}%
%}{\endquotation}  

% berschriften
%\renewcommand{\section}{\@startsection{section}{1}{\z@}%
%  {2\baselineskip}{\baselineskip}{\fontsize{12}{14}\fontseries{b}\selectfont}}
%\renewcommand{\subsection}{\@startsection{subsection}{2}{\z@}%
%  {2\baselineskip}{\baselineskip}{\fontsize{10}{12}\fontseries{b}\selectfont}}
%\renewcommand{\subsubsection}{\@startsection{subsubsection}{3}{\z@}%
%  {2\baselineskip}{\baselineskip}{\fontsize{10}{8}\fontseries{b}\selectfont}}
% weitere nicht durch Formatvorlage geklrt

% keine seitennummern oh doch
% \pagestyle{empty}

%\fancyhead[EL]{}
%\fancyhead[EC]{}
%\fancyhead[ER]{}
%\fancyhead[OL]{}
%\fancyhead[OC]{}
%\fancyhead[OR]{}
%\renewcommand\headrulewidth{0pt}
%\fancyfoot[EC]{}
%\fancyfoot[OC]{}
%\fancyfoot[EL]{\thepage}
%\fancyfoot[OR]{\thepage}

% Bildunterschriften
\long\def\@makecaption#1#2{%
  \vskip\abovecaptionskip
  {\fontsize{12}{10}\selectfont\bfseries
   \sbox\@tempboxa{#1: #2}%
  \ifdim \wd\@tempboxa >\hsize
    #1: #2\par
  \else
    \global \@minipagefalse
    \hb@xt@\hsize{\hfil\box\@tempboxa\hfil}%
  \fi}
  \vskip\belowcaptionskip}

% gleichungen mit richtiger einrckung
% fleqn-Option oben
\setlength{\mathindent}{4ex}

% listings mit richtiger einrckung
\RequirePackage{verbatim}
\def\verbatim@processline{\hskip4ex\the\verbatim@line\par}

% Fussnoten mit 5cm Linie und richtiger Gre
\renewcommand\footnoterule{%
  \kern-3\p@
  \hrule\@width5cm
  \kern2.6\p@}

% bibliography
\iflanguage{english}{\bibliographystyle{alphadin}}{\bibliographystyle{alphadin}}
\renewenvironment{thebibliography}[1]
     {%\def\refname{Literaturverzeichnis}
      \section{\refname}%
      \bgroup\fontsize{12}{10}\selectfont					% fontsize gendert: uh
      \vspace{12pt}                               % vertikler Abstand hinzugefgt: uh
      \list{\@biblabel{\@arabic\c@enumiv}}%
           {\settowidth\labelwidth{\@biblabel{#1}}%
            \leftmargin\labelwidth
            \advance\leftmargin\labelsep
            \@openbib@code
            \usecounter{enumiv}%
            \let\p@enumiv\@empty
            \renewcommand\theenumiv{\@arabic\c@enumiv}}%
      \sloppy
      \clubpenalty4000
      \@clubpenalty \clubpenalty
      \widowpenalty4000%
      \sfcode`\.\@m}
     {\def\@noitemerr
       {\@latex@warning{Empty `thebibliography' environment}}%
      \endlist\egroup}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% nderungen von Udo Huscheck
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Einrckungen
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\setlength{\parindent}{1.2em}
\setlength{\parskip}{0em}

%Zeilenabstand
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\setlength{\baselineskip}{1.2pt}

% Rnder setzen
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\usepackage{vmargin}
\setpapersize{A4}
\setmargins{3.5cm}{1.4cm}%   % linker & oberer Rand
           {15cm}{24.5cm}%   % Textbreite und -hoehe
           {14.5pt}{25pt}%   % Kopfzeilenhoehe und -abstand
           {0pt}{8.4pt}%     % Fuzeilenhhe und Fusszeilenabstand

% Kopf- und Fuzeilen
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\usepackage{fancyhdr}
\pagestyle{fancy}

\rhead{\thepage}
\lhead{\nouppercase{\leftmark}}
\cfoot{}

\newcommand\headmark[1]{\@mkboth{#1}{#1}}


% Formatierung des Tabellenverzeichnisses
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\usepackage{tocloft}
\renewcommand{\cftdotsep}{0.3}
\renewcommand{\cftsecdotsep}{0.3}
\renewcommand{\cftsubsecdotsep}{0.3}
\renewcommand{\cftsubsubsecdotsep}{0.3}\setlength{\cftbeforesecskip}{10pt}
\setlength{\cftbeforesubsecskip}{2pt}
\setlength{\cftsubsecindent}{1.3em}
\setlength{\cftsubsubsecindent}{3.3em}
\setlength{\cftsecnumwidth}{1.3em}
\setlength{\cftsubsecnumwidth}{2em}
\setlength{\cftsubsubsecnumwidth}{2.7em}
\renewcommand{\cfttoctitlefont}{\fontfamily{phv}\fontseries{m}\fontshape{n}\fontsize{16}{16}\selectfont\bfseries}
\renewcommand{\cftloftitlefont}{\fontfamily{phv}\fontseries{m}\fontshape{n}\fontsize{16}{16}\selectfont\bfseries}
\renewcommand{\cftlottitlefont}{\fontfamily{phv}\fontseries{m}\fontshape{n}\fontsize{16}{16}\selectfont\bfseries}

%Formatierung des Abbildungsverzeichnisses
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\renewcommand{\figurename}{\textit{Abbildung}}
\renewcommand{\cftfigpresnum}{Abbildung~}
\renewcommand{\cftfigaftersnum}{:}
\settowidth{\cftfignumwidth}{\thefigure\cftfigpresnum}
\addtolength{\cftfignumwidth}{1ex}
\setlength{\cftfigindent}{0em}

%Formatierung des Tabellenverzeichnisses
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\renewcommand{\tablename}{\textit{Tabelle}}
\renewcommand{\cfttabpresnum}{Table~}
\renewcommand{\cfttabaftersnum}{:}
\settowidth{\cfttabnumwidth}{\thetable\cfttabpresnum}
\addtolength{\cfttabnumwidth}{1ex}
\setlength{\cfttabindent}{0em}

%Formatierung berschriften
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\usepackage{helvet}
\makeatletter
  \renewcommand\section{\@startsection{section}{1}{0cm}{12pt}{6pt}%
  {\fontfamily{phv}\fontseries{m}\fontshape{n}\fontsize{16}{16}\selectfont\bfseries}}%
  \renewcommand\subsection{\@startsection{subsection}{2}{0cm}{12pt}{6pt}%
  {\fontfamily{phv}\fontseries{m}\fontshape{n}\fontsize{14}{16}\selectfont\bfseries}}%
  \renewcommand\subsubsection{\@startsection{subsubsection}{3}{0cm}{12pt}{6pt}%
  {\fontfamily{phv}\fontseries{m}\fontshape{n}\fontsize{12}{16}\selectfont\bfseries}}%
\makeatother

%Funoten
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\makeatletter
  \renewcommand\@makefntext[1]{\noindent\makebox[1em][l]{\textsuperscript{\@thefnmark}~#1}}%
\makeatother
\setlength{\skip\footins}{20pt}

%Aufzhlungen
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\usepackage[pointedenum]{paralist}
\renewcommand{\labelitemii}{\raisebox{0.1ex}{\fontsize{14}{12}\selectfont$\circ$}}
\renewcommand{\labelitemiii}{\raisebox{0.6ex}{\fontsize{6}{6}\selectfont$\blacksquare$}}

\newcommand\bitemlist[1][t]
{\setdefaultleftmargin{1.5em}{1.7em}{1.5em}{}{}{}
 \if i#1
    \setlength{\pltopsep}{0pt}\begin{compactitem}
 \else
    \setlength{\pltopsep}{12pt}\begin{compactitem}
 \fi
}
\newcommand\eitemlist{\end{compactitem}}

\newcommand\benumlist[1][t]
{\setdefaultleftmargin{1.8em}{2em}{2.8em}{}{}{}
 \if i#1
    \setlength{\pltopsep}{0pt}\begin{compactenum}
 \else
    \setlength{\pltopsep}{12pt}\begin{compactenum}
 \fi
}
\newcommand\eenumlist{\end{compactenum}}

%Abbildungs- und Tabellenbeschriftung
%%%%%%%%%%%%%%%%%%%%%%%%%%%
\setlength{\abovecaptionskip}{0pt}
\setlength{\belowcaptionskip}{0pt}

%#1: Eintrag im lof/lot (optional)
%#2: Caption der Abbildung/Tabelle
\newcommand{\mylotfentry}{}
\newcommand{\mycaption}{}
\newcommand\makecap[2][\mycaption]{
    \renewcommand{\mylotfentry}{#1}%
    \renewcommand{\mycaption}{#2}%
    \caption[\mylotfentry]{\bfseries \mycaption.}%
}%

%direkte Zitate
%%%%%%%%%%%%%%%%%%%%%%%%%

%#1: Text des Zitats
%#2: Quellenangabe
\newcommand\dc[2]{\vspace{0.5cm}\\\indent\glqq\emph{#1}\grqq\footnote{#2}\vspace{0.5cm}}

%Definition
%%%%%%%%%%%%%%%%%%%%%%%

%#1: Definitionsbegriff
%#2: Definitionstext
\newcommand\definition[2]{%
\begin{list}{}{
    \setlength{\leftmargin}{1cm}
    \setlength{\itemindent}{-1cm}
}
    \item \textbf{#1:}~\setlength{\parindent}{1.2em}\setlength{\parskip}{0em}#2
\end{list}%
}

%Titelblatt
%%%%%%%%%%%%%%%%%%%%%

% #1: Titel der Diplomarbeit
% #2: Titel und Name des Hochschullehrers
% #3: Titel und Name des Betreuers
% #4: Ort, Monat Jahr (Monat ausgeschrieben, Jahr vierstellig)
% #5: Nachname, Vorname des Studenten
\newcommand\makediptitle[5]{
    {
        \setlength{\parindent}{0em}
        \thispagestyle{empty}

        \makebox(420,115)[b]{\parbox{400pt}{\center\fontsize{14}{12}\fontseries{b}\selectfont\setlength{\baselineskip}{18pt}
        Universitt Leipzig\\Fakultt fr Mathematik und Informatik\\Institut fr Informatik}}\\
        \makebox(426,220){\parbox{400pt}{\center\fontsize{14}{12}\selectfont #1}}\\
        \makebox(426,45)[t]{\parbox{400pt}{\center\fontsize{18}{12}\fontseries{b}\selectfont Diplomarbeit}}\\
        \makebox(426,140)[t]{\parbox{400pt}{}}\\
        \makebox(220,30)[lt]{\parbox{210pt}{Betreuender Hochschullehrer:}}
        \makebox(204,30)[rt]{\parbox[t]{180pt}{\raggedleft #2}}\\
        \makebox(220,30)[lt]{\parbox{210pt}{Betreuender Assistent:}}
        \makebox(204,30)[rt]{\parbox[t]{180pt}{\raggedleft #3}}\\
        \makebox(220,35)[lt]{\parbox{210pt}{#4}}
        \makebox(204,35)[rt]{\parbox[t]{180pt}{\raggedleft vorgelegt von:}}\\
        \makebox(426,20)[t]{\parbox{426pt}{\fontsize{14}{12}\selectfont \raggedleft #5\\~\\~\\~\\~\\Studiengang Informatik}}\\
    }
    \newpage
    \pagenumbering{roman}
}

% #1: Titel der Seminararbeit
% #2: Seminartitel
% #3: Semester, in Form von: SS yyyy bzw. WS yyyy
% #4: Dozenten des Seminars
% #5: Ort, Monat Jahr
% #6: Nachname, Vorname des Studenten
% #7: Fachsemester des Studenten
% #8: Matrikelnummer des Studenten
\newcommand\makesemtitle[8]{
    {
        \setlength{\parindent}{0em}
        \thispagestyle{empty}

        \makebox(420,115)[b]{\parbox{400pt}{\center\fontsize{14}{12}\fontseries{b}\selectfont\setlength{\baselineskip}{18pt}
        Universitt Leipzig\\Fakultt fr Mathematik und Informatik\\Institut fr Informatik}}\\
        \makebox(426,220){\parbox{400pt}{\center\fontsize{14}{12}\selectfont #1}}\\
        \makebox(426,45)[t]{\parbox{400pt}{\center\fontsize{18}{12}\fontseries{b}\selectfont Seminararbeit}}\\
        \makebox(426,140)[t]{\parbox{400pt}{\center Seminar:~#2\\#3}}\\
        \makebox(220,61)[lt]{\parbox{210pt}{Dozenten:}}
        \makebox(204,61)[rt]{\parbox[t]{180pt}{\raggedleft #4}}\\
        \makebox(220,35)[lt]{\parbox{210pt}{#5}}
        \makebox(204,35)[rt]{\parbox[t]{180pt}{\raggedleft vorgelegt von:}}\\
        \makebox(426,20)[t]{\parbox{426pt}{\fontsize{14}{12}\selectfont\setlength{\baselineskip}{18pt}\raggedleft #6\\#7.~Semester
                                           \\Matr.-Nr.~#8\\Studiengang Informatik}}\\
    }
    \newpage
    \pagenumbering{roman}
}

%Erklrung
%%%%%%%%%%%%%%%%%%%%%%

% #1: Ort
% #2: Datum: Tag (als zweistellige Zahl). Monat (ausgeschrieben) Jahr (vierstellig)
% #3: Vorname Name
\newcommand\state[3]{
    \noindent Ich versichere, dass ich die vorliegende Arbeit selbstndig und nur unter Verwendung der angegebenen Quellen und 
    Hilfsmittel angefertigt habe.\\
    
    \makebox(426,61)[t]{}\\
    \makebox(220,20)[lt]{\parbox{210pt}{\noindent #1, den #2}}
    \makebox(204,20)[rt]{\parbox[t]{180pt}{\raggedleft vorgelegt von: #3}}\\
    }

%Schusterjungen und Hurenkinder vermeiden
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\clubpenalty = 10000
\widowpenalty = 10000 
\displaywidowpenalty = 10000
